import { ComponentClass, SFC } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { TMenuProps } from '../Menu/Menu';
import { TInputProps } from '../input/Input';
import { TPopoverProps } from '../Popover/Popover';
import { TAutocompleteMenuItemProps } from './AutocompleteMenuItem';
export declare const AUTOCOMPLETE: symbol;
export declare type TFullAutocompleteProps = TInputProps & {
    Input: ComponentClass<TInputProps>;
    Popover: ComponentClass<TPopoverProps> | SFC<TPopoverProps>;
    Menu: ComponentClass<TMenuProps> | SFC<TMenuProps>;
    MenuItem: ComponentClass<TAutocompleteMenuItemProps>;
    value: string;
    data: any[];
    filter: (value: string) => (item: any, index: number) => boolean;
    theme: {
        container?: string;
        Input?: TInputProps['theme'];
        Popover?: TPopoverProps['theme'];
        Menu?: TMenuProps['theme'];
        MenuItem?: TAutocompleteMenuItemProps['theme'];
    };
};
export declare type TAutocompleteProps = PartialKeys<TFullAutocompleteProps, 'theme' | 'Input' | 'Popover' | 'MenuItem' | 'Menu'>;
export declare const Autocomplete: ComponentClass<TAutocompleteProps>;
