"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var classnames = require("classnames");
var pure_1 = require("../../utils/pure");
var LoadingIndicator_1 = require("../LoadingIndicator/LoadingIndicator");
var withTheme_1 = require("../../utils/withTheme");
exports.BUTTON = Symbol('Button');
var RawButton = /** @class */ (function (_super) {
    tslib_1.__extends(RawButton, _super);
    function RawButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawButton.prototype.render = function () {
        var _a;
        var _b = this.props, theme = _b.theme, style = _b.style, type = _b.type, children = _b.children, onMouseLeave = _b.onMouseLeave, onMouseDown = _b.onMouseDown, onMouseUp = _b.onMouseUp, onMouseEnter = _b.onMouseEnter, onMouseMove = _b.onMouseMove, onMouseOut = _b.onMouseOut, onMouseOver = _b.onMouseOver, onDoubleClick = _b.onDoubleClick, onDrag = _b.onDrag, onDragEnd = _b.onDragEnd, onDragEnter = _b.onDragEnter, onDragExit = _b.onDragExit, onDragLeave = _b.onDragLeave, onDragOver = _b.onDragOver, onDragStart = _b.onDragStart, onDrop = _b.onDrop, onClick = _b.onClick, onTouchCancel = _b.onTouchCancel, onTouchEnd = _b.onTouchEnd, onTouchMove = _b.onTouchMove, onTouchStart = _b.onTouchStart, isFlat = _b.isFlat, isPrimary = _b.isPrimary, isLoading = _b.isLoading, isDisabled = _b.isDisabled, tabIndex = _b.tabIndex;
        var className = classnames(theme.container, (_a = {},
            _a[theme.container_primary] = isPrimary,
            _a[theme.container_flat] = isFlat,
            _a[theme.container_isLoading] = isLoading,
            _a));
        return (React.createElement("button", { className: className, onMouseLeave: onMouseLeave, onMouseDown: onMouseDown, onMouseUp: onMouseUp, onMouseEnter: onMouseEnter, onMouseMove: onMouseMove, onMouseOut: onMouseOut, onMouseOver: onMouseOver, onDoubleClick: onDoubleClick, onDrag: onDrag, onDragEnd: onDragEnd, onDragEnter: onDragEnter, onDragExit: onDragExit, onDragLeave: onDragLeave, onDragOver: onDragOver, onDragStart: onDragStart, onDrop: onDrop, onClick: onClick, onTouchCancel: onTouchCancel, onTouchEnd: onTouchEnd, onTouchMove: onTouchMove, onTouchStart: onTouchStart, type: type, style: style, tabIndex: tabIndex, disabled: isDisabled },
            children,
            isLoading && (React.createElement("div", { className: theme.loadingIndicator },
                React.createElement(LoadingIndicator_1.LoadingIndicator, { theme: theme.LoadingIndicator })))));
    };
    RawButton.defaultProps = {
        type: 'button',
    };
    RawButton = tslib_1.__decorate([
        pure_1.PURE
    ], RawButton);
    return RawButton;
}(React.Component));
exports.Button = withTheme_1.withTheme(exports.BUTTON)(RawButton);
//# sourceMappingURL=Button.js.map