"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var pure_1 = require("../../utils/pure");
var classnames = require("classnames");
var Demo_1 = require("../demo/Demo");
var checkbox_tick_icon_1 = require("../../icons/checkbox-tick-icon");
var Checkbox_1 = require("./Checkbox");
var storybook_1 = require("@devexperts/tools/dist/utils/storybook");
var css = require("./Checkbox.page.styl");
var darkDemoTheme = {
    container: css.container,
    view: css.view,
    icon: css.icon,
    icon_isDisabled: css.icon_isDisabled,
};
exports.CHECKBOX = 'Checkbox';
var CheckboxPage = /** @class */ (function (_super) {
    tslib_1.__extends(CheckboxPage, _super);
    function CheckboxPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isChecked: true,
        };
        _this.onChangeHandler = function (value) {
            _this.setState({
                isChecked: Boolean(value),
            });
        };
        return _this;
    }
    CheckboxPage.prototype.render = function () {
        var _a;
        var labelClassName = classnames(css.label, (_a = {},
            _a[css.label_isDisabled] = this.props.isDisabled,
            _a));
        return (React.createElement(Demo_1.default, null,
            React.createElement("div", { className: css.container },
                React.createElement("label", { htmlFor: "check1", className: labelClassName },
                    React.createElement(Checkbox_1.Checkbox, { theme: darkDemoTheme, checkMark: React.createElement(checkbox_tick_icon_1.CheckboxTickIcon, null), value: this.state.isChecked, onValueChange: this.onChangeHandler, isDisabled: this.props.isDisabled, id: "check1" }),
                    "I'am controlled checkbox"))));
    };
    CheckboxPage = tslib_1.__decorate([
        pure_1.PURE
    ], CheckboxPage);
    return CheckboxPage;
}(React.Component));
storybook_1.storiesOf('Checkbox', module)
    .add('default', function () {
    return React.createElement(CheckboxPage, { isDisabled: storybook_1.knobs.boolean('isDisabled', false) });
})
    .add('disabled', function () { return React.createElement(CheckboxPage, { isDisabled: true }); });
//# sourceMappingURL=Checkbox.page.js.map