import { Option } from 'fp-ts/lib/Option';
export declare type TDateInputValue = {
    day: Option<number>;
    month: Option<number>;
    year: Option<number>;
};
export declare const isDatesDifferent: (x: TDateInputValue, y: TDateInputValue) => boolean;
export declare const buildDate: (day: number) => (month: number) => (year: number) => Date;
export declare const buildDateOption: import("fp-ts/lib/function").Curried3<Option<number>, Option<number>, Option<number>, Option<Date>>;
export declare enum DateFormatType {
    MDY = 0,
    DMY = 1
}
export declare type TDateInputState = {
    activeSection?: ActiveSection;
    isOpened?: boolean;
};
export declare enum ActiveSection {
    Day = 0,
    Month = 1,
    Year = 2
}
export declare const toObjectDate: (date: Date) => TDateInputValue;
export declare function format(date: Option<number>, section: ActiveSection): string;
export declare function decrementMonth(month: number): number;
export declare function decrementMonthOption(month: Option<number>): Option<number>;
export declare function incrementMonth(month: number): number;
export declare function incrementMonthOption(month: Option<number>): Option<number>;
