"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var with_defaults_1 = require("../../utils/with-defaults");
var RawDeferred = /** @class */ (function (_super) {
    tslib_1.__extends(RawDeferred, _super);
    function RawDeferred() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isResolved: false,
        };
        return _this;
    }
    RawDeferred.prototype.componentWillMount = function () {
        this.delay();
    };
    RawDeferred.prototype.componentWillUnmount = function () {
        clearTimeout(this.timeout);
    };
    RawDeferred.prototype.componentWillUpdate = function () {
        console.log('update');
        clearTimeout(this.timeout);
        this.delay();
    };
    RawDeferred.prototype.render = function () {
        var isResolved = this.state.isResolved;
        var _a = this.props, render = _a.render, children = _a.children;
        return isResolved ? render() : (children || null); //weird React typings...
    };
    RawDeferred.prototype.delay = function () {
        var _this = this;
        this.timeout = window.setTimeout(function () {
            _this.setState({
                isResolved: true,
            });
        }, this.props.delay);
    };
    return RawDeferred;
}(react_1.PureComponent));
exports.Deferred = with_defaults_1.withDefaults({
    delay: 0,
})(RawDeferred);
//# sourceMappingURL=Deferred.js.map