import * as React from 'react';
import { TFullTableProps, TTableProps, TFullTableBodyProps, TFullTableRowProps, TFullTableCellProps, TFullTableHeadProps, TTableHeadProps, TTableRowProps, TTableCellProps, TTableTheme } from '../Table/Table';
import { Omit } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare const GRID: symbol;
export declare type TFullGridProps = Omit<TFullTableProps, 'theme'> & {
    theme: TTableTheme & {
        gridHead?: string;
        gridHead_paddedForScrollbar?: string;
        gridHead__content?: string;
        gridBody?: string;
        horizontal_scrollbar__bar?: string;
        vertical_scrollbar__bar?: string;
        gridCell__content?: string;
        gridCell__content_left?: string;
        gridCell__content_center?: string;
        gridCell__content_right?: string;
        cell_left?: string;
        cell_center?: string;
        cell_right?: string;
        gridCell__placeholder?: string;
    };
};
export declare type TFullGridHeadProps = TFullGridProps & TFullTableHeadProps & {
    Table?: React.ComponentClass<TTableProps>;
    TableHead?: React.ComponentClass<TTableHeadProps>;
};
export declare type TFullGridBodyProps = TFullGridProps & TFullTableBodyProps & {
    Table?: React.ComponentClass<TTableProps>;
    TableBody?: React.ComponentClass<TTableHeadProps>;
};
export declare type TFullGridRowProps = TFullGridProps & TFullTableRowProps & {
    TableRow?: React.ComponentClass<TTableRowProps>;
    gridRowIndexKey?: number;
};
/**
 * @enum
 */
export declare enum GridCellAlignment {
    LEFT = "GRID_CELL_ALIGN:LEFT",
    CENTER = "GRID_CELL_ALIGN:CENTER",
    RIGHT = "GRID_CELL_ALIGN:RIGHT"
}
export declare type TFullGridCellProps = TFullGridProps & TFullTableCellProps & {
    TableCell?: React.ComponentClass<TTableCellProps>;
    gridRowIndexKey?: number;
    gridColumnIndexKey?: number;
    gridColumnWidth?: number;
    align?: GridCellAlignment;
};
export declare type TGridProps = PartialKeys<TFullGridProps, 'theme'>;
export declare const Grid: React.ComponentClass<TGridProps>;
export declare type TGridBodyProps = PartialKeys<TFullGridBodyProps, 'theme'>;
export declare const GridBody: React.ComponentClass<TGridBodyProps>;
export declare type TGridHeadProps = PartialKeys<TFullGridHeadProps, 'theme'>;
export declare const GridHead: React.ComponentClass<TGridHeadProps>;
export declare type TGridRowProps = PartialKeys<TFullGridRowProps, 'theme'>;
export declare const GridRow: React.ComponentClass<TGridRowProps>;
export declare type TGridCellProps = PartialKeys<TFullGridCellProps, 'theme'>;
export declare const GridCell: React.ComponentClass<TGridCellProps>;
