"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var _a;
var React = require("react");
var classnames = require("classnames");
var withTheme_1 = require("../../utils/withTheme");
var pure_1 = require("../../utils/pure");
exports.LIST = Symbol('List');
var CONTEXT_LEVEL_KEY = '__LIST_CONTEXT_LEVEL_KEY__';
var CONTEXT_TYPES = (_a = {},
    _a[CONTEXT_LEVEL_KEY] = function () { },
    _a);
var RawList = /** @class */ (function (_super) {
    tslib_1.__extends(RawList, _super);
    function RawList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawList.prototype.render = function () {
        var level = this.context[CONTEXT_LEVEL_KEY] || 0;
        var _a = this.props, theme = _a.theme, children = _a.children;
        var className = classnames(theme.container, theme["container_level_" + level]);
        return React.createElement("ul", { className: className }, children);
    };
    RawList.contextTypes = CONTEXT_TYPES;
    return RawList;
}(React.Component));
exports.List = withTheme_1.withTheme(exports.LIST)(RawList);
var RawListItem = /** @class */ (function (_super) {
    tslib_1.__extends(RawListItem, _super);
    function RawListItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawListItem.prototype.render = function () {
        var _a = this.props, theme = _a.theme, onClick = _a.onClick, children = _a.children;
        var level = this.context[CONTEXT_LEVEL_KEY] || 0;
        var className = classnames(theme.item, theme["item_level_" + level]);
        return (React.createElement("li", { className: className, onClick: onClick }, children));
    };
    RawListItem.contextTypes = CONTEXT_TYPES;
    RawListItem = tslib_1.__decorate([
        pure_1.PURE
    ], RawListItem);
    return RawListItem;
}(React.Component));
exports.ListItem = withTheme_1.withTheme(exports.LIST)(RawListItem);
var RawListItemGroup = /** @class */ (function (_super) {
    tslib_1.__extends(RawListItemGroup, _super);
    function RawListItemGroup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawListItemGroup.prototype.getChildContext = function () {
        var _a;
        return _a = {},
            _a[CONTEXT_LEVEL_KEY] = (this.context[CONTEXT_LEVEL_KEY] || 0) + 1,
            _a;
    };
    RawListItemGroup.prototype.render = function () {
        var _a;
        var _b = this.props, theme = _b.theme, isCollapsed = _b.isCollapsed, children = _b.children, header = _b.header, onClick = _b.onClick;
        var level = this.context[CONTEXT_LEVEL_KEY] || 0;
        var className = classnames(theme.itemGroup, theme["itemGroup_level_" + level], (_a = {},
            _a[theme.itemGroup_isCollapsed] = isCollapsed,
            _a));
        return (React.createElement("li", { className: className },
            React.createElement("span", { className: theme.itemGroup__header, onClick: onClick }, header),
            children));
    };
    RawListItemGroup.defaultProps = {
        isCollapsed: false,
    };
    RawListItemGroup.contextTypes = CONTEXT_TYPES;
    RawListItemGroup.childContextTypes = CONTEXT_TYPES;
    return RawListItemGroup;
}(React.Component));
exports.ListItemGroup = withTheme_1.withTheme(exports.LIST)(RawListItemGroup);
//# sourceMappingURL=List.js.map