"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var pure_1 = require("../../utils/pure");
var ButtonIcon_1 = require("../ButtonIcon/ButtonIcon");
var Input_1 = require("../input/Input");
var withTheme_1 = require("../../utils/withTheme");
exports.PASSWORD_INPUT = Symbol('PasswordInput');
var RawPasswordInput = /** @class */ (function (_super) {
    tslib_1.__extends(RawPasswordInput, _super);
    function RawPasswordInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClickRevealButton = function () {
            var onReveal = _this.props.onReveal;
            onReveal && onReveal(!_this.props.isRevealed);
        };
        return _this;
    }
    RawPasswordInput.prototype.render = function () {
        var _a = this.props, theme = _a.theme, _b = _a.Button, Button = _b === void 0 ? ButtonIcon_1.ButtonIcon : _b, _c = _a.Input, Input = _c === void 0 ? Input_1.Input : _c, IconShow = _a.IconShow, IconHide = _a.IconHide, isDisabled = _a.isDisabled, isRevealed = _a.isRevealed, onReveal = _a.onReveal, restInputProps = tslib_1.__rest(_a, ["theme", "Button", "Input", "IconShow", "IconHide", "isDisabled", "isRevealed", "onReveal"]);
        var Icon = isRevealed ? IconShow : IconHide;
        return (React.createElement("div", { className: theme.container },
            React.createElement(Input, tslib_1.__assign({}, restInputProps, { theme: theme.Input, isDisabled: isDisabled, type: isRevealed ? 'text' : 'password' })),
            React.createElement(Button, { icon: React.createElement(Icon, null), theme: theme.RevealButton, isDisabled: isDisabled, onClick: this.onClickRevealButton })));
    };
    RawPasswordInput = tslib_1.__decorate([
        pure_1.PURE
    ], RawPasswordInput);
    return RawPasswordInput;
}(React.Component));
exports.RawPasswordInput = RawPasswordInput;
exports.PasswordInput = withTheme_1.withTheme(exports.PASSWORD_INPUT)(RawPasswordInput);
//# sourceMappingURL=PasswordInput.js.map