"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Demo_1 = require("../demo/Demo");
var storybook_1 = require("@devexperts/tools/dist/utils/storybook");
var PasswordInput_1 = require("./PasswordInput");
var pure_1 = require("../../utils/pure");
var css = require("./PasswordInput.page.styl");
var show_password_icon_1 = require("../../icons/show-password-icon");
var hide_password_icon_1 = require("../../icons/hide-password-icon");
var darkDemoTheme = {
    container: css.container,
};
var PasswordInputPage = /** @class */ (function (_super) {
    tslib_1.__extends(PasswordInputPage, _super);
    function PasswordInputPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: 'test',
            isRevealed: false,
        };
        _this.onChange = function (value) {
            storybook_1.action('value changed')(value);
            _this.setState({
                value: value,
            });
        };
        _this.onReveal = function (isRevealed) {
            storybook_1.action('isRevealed changed')(isRevealed);
            _this.setState({
                isRevealed: isRevealed,
            });
        };
        return _this;
    }
    PasswordInputPage.prototype.render = function () {
        var isRevealed = this.state.isRevealed;
        return (React.createElement(Demo_1.default, { theme: darkDemoTheme },
            React.createElement("main", null,
                React.createElement("section", { className: css.form },
                    React.createElement(PasswordInput_1.PasswordInput, { onValueChange: this.onChange, IconShow: show_password_icon_1.ShowPasswordIcon, value: this.state.value, onReveal: this.onReveal, isRevealed: isRevealed, IconHide: hide_password_icon_1.HidePasswordIcon })))));
    };
    PasswordInputPage = tslib_1.__decorate([
        pure_1.PURE
    ], PasswordInputPage);
    return PasswordInputPage;
}(React.Component));
storybook_1.storiesOf('PasswordInput', module).add('default', function () { return React.createElement(PasswordInputPage, null); });
//# sourceMappingURL=PasswordInput.page.js.map