"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Demo_1 = require("../../demo/Demo");
var Button_1 = require("../../Button/Button");
var Popover_1 = require("../Popover");
var Popover_model_1 = require("../Popover.model");
var Selectbox_1 = require("../../Selectbox/Selectbox");
var Menu_1 = require("../../Menu/Menu");
var pure_1 = require("../../../utils/pure");
var storybook_1 = require("@devexperts/tools/dist/utils/storybook");
var Control_1 = require("../../Control/Control");
var css = require("./theme/Popover.page.styl");
var Scrollable_1 = require("../../Scrollable/Scrollable");
var InputWithPopover_page_1 = require("./InputWithPopover.page");
var FixedPopover_page_1 = require("./FixedPopover.page");
var buttonTheme = {
    container: css.toggleButton,
};
var HeavyContent = /** @class */ (function (_super) {
    tslib_1.__extends(HeavyContent, _super);
    function HeavyContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeavyContent.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement(Scrollable_1.Scrollable, null,
                React.createElement("div", { className: css.heavy },
                    React.createElement("h2", null, "Tethered Content"),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title."),
                    React.createElement("p", null, "A paragraph to accompany the title.")))));
    };
    HeavyContent = tslib_1.__decorate([
        pure_1.PURE
    ], HeavyContent);
    return HeavyContent;
}(React.Component));
var Stateful = Control_1.stateful()(Selectbox_1.Selectbox);
var StatefulOpened = Control_1.stateful('isOpened', 'onToggle', 'defaultIsOpened')(Stateful);
var PopoverPage = /** @class */ (function (_super) {
    tslib_1.__extends(PopoverPage, _super);
    function PopoverPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            placement: Popover_model_1.PopoverPlacement.Bottom,
            align: Popover_model_1.PopoverAlign.Left,
            isOpened: false,
            isLongText: false,
            closeOnClickAway: false,
        };
        _this.onPlacementSelect = function (placement) {
            var placementWasVertical = [Popover_model_1.PopoverPlacement.Top, Popover_model_1.PopoverPlacement.Bottom].includes(_this.state.placement);
            var placementWillBeVertical = [Popover_model_1.PopoverPlacement.Top, Popover_model_1.PopoverPlacement.Bottom].includes(placement);
            if (placementWasVertical && !placementWillBeVertical) {
                //placement orientation changed from vertical to horizontal
                //choose default vertical align
                _this.setState({
                    align: Popover_model_1.PopoverAlign.Top,
                });
            }
            else if (!placementWasVertical && placementWillBeVertical) {
                //placement orientation changed from horizontal to vertical
                //choose default horizontal align
                _this.setState({
                    align: Popover_model_1.PopoverAlign.Left,
                });
            }
            //finally set placement
            _this.setState({
                placement: placement,
            });
        };
        _this.onAlignSelect = function (align) {
            _this.setState({
                align: align,
            });
        };
        _this.onToggleClick = function () {
            _this.setState({
                isOpened: !_this.state.isOpened,
            });
        };
        _this.onPopoverRequestClose = function () {
            _this.setState({
                isOpened: false,
            });
        };
        _this.onCloseOnClickAwayChange = function () {
            _this.setState({
                closeOnClickAway: !_this.state.closeOnClickAway,
            });
        };
        return _this;
    }
    PopoverPage.prototype.render = function () {
        var _this = this;
        var _a = this.state, placement = _a.placement, align = _a.align, isOpened = _a.isOpened, closeOnClickAway = _a.closeOnClickAway;
        return (React.createElement(Demo_1.default, null,
            React.createElement("div", { className: css.container },
                React.createElement("div", null,
                    React.createElement("label", { className: css.label }, "Placement"),
                    React.createElement(StatefulOpened, { defaultIsOpened: false, defaultValue: Popover_model_1.PopoverPlacement.Bottom, onValueChange: this.onPlacementSelect },
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Top }, "Top"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Bottom }, "Bottom"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Left }, "Left"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverPlacement.Right }, "Right")),
                    React.createElement("label", { className: css.label }, "Align"),
                    (placement === Popover_model_1.PopoverPlacement.Top || placement === Popover_model_1.PopoverPlacement.Bottom) && (React.createElement(StatefulOpened, { defaultIsOpened: false, defaultValue: Popover_model_1.PopoverAlign.Left, onValueChange: this.onAlignSelect },
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Left }, "Left"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Center }, "Center"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Right }, "Right"))),
                    (placement === Popover_model_1.PopoverPlacement.Left || placement === Popover_model_1.PopoverPlacement.Right) && (React.createElement(StatefulOpened, { defaultIsOpened: false, defaultValue: Popover_model_1.PopoverAlign.Top, onValueChange: this.onAlignSelect },
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Top }, "Top"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Middle }, "Middle"),
                        React.createElement(Menu_1.MenuItem, { value: Popover_model_1.PopoverAlign.Bottom }, "Bottom"))),
                    React.createElement("label", { className: css.label },
                        "Close on clickaway",
                        ' ',
                        React.createElement("input", { type: "checkbox", value: closeOnClickAway.toString(), onChange: this.onCloseOnClickAwayChange }))),
                React.createElement(Button_1.Button, { isPrimary: true, onClick: this.onToggleClick, ref: function (el) { return (_this._anchor = el); }, theme: buttonTheme },
                    isOpened ? 'Hide' : 'Open',
                    React.createElement(Popover_1.Popover, { placement: placement, isOpened: isOpened, onRequestClose: this.onPopoverRequestClose, closeOnClickAway: closeOnClickAway, hasArrow: true, align: align, anchor: this._anchor },
                        React.createElement(HeavyContent, null))))));
    };
    PopoverPage = tslib_1.__decorate([
        pure_1.PURE
    ], PopoverPage);
    return PopoverPage;
}(React.Component));
storybook_1.storiesOf('Popover', module)
    .add('default', function () { return React.createElement(PopoverPage, null); })
    .add('input with popover', function () { return React.createElement(InputWithPopover_page_1.InputWithPopoverPage, null); })
    .add('fixed popover', function () { return React.createElement(FixedPopover_page_1.FixedPopoverPage, null); });
//# sourceMappingURL=Popover.page.js.map