"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_dom_1 = require("react-dom");
var pure_1 = require("../../utils/pure");
var react_1 = require("react");
var withTheme_1 = require("../../utils/withTheme");
var RootClose_1 = require("../RootClose/RootClose");
var popup_ui_component_1 = require("./popup-ui.component");
var with_defaults_1 = require("../../utils/with-defaults");
exports.POPUP = Symbol('Popup');
var RawPopup = /** @class */ (function (_super) {
    tslib_1.__extends(RawPopup, _super);
    function RawPopup(props) {
        var _this = _super.call(this, props) || this;
        _this.backdrop = null;
        _this.innerRef = function (backdrop) {
            _this.backdrop = backdrop;
        };
        _this.handleBackdropClick = function (e) {
            var _a = _this.props, shouldCloseOnClickAway = _a.shouldCloseOnClickAway, onRequestClose = _a.onRequestClose;
            if (shouldCloseOnClickAway && onRequestClose) {
                var isModal = _this.props.isModal;
                if (isModal) {
                    //popup is modal - backdrop handles clicks
                    //don't process click inside popup container (bubbled events)
                    if (e.target === _this.backdrop) {
                        onRequestClose();
                    }
                }
                //if popup isn't modal then it's closed by RootClose
            }
        };
        _this.rootElement = document.createElement('div');
        var container = props.container || document.body;
        container.appendChild(_this.rootElement);
        return _this;
    }
    RawPopup.prototype.componentWillUnmount = function () {
        var container = this.props.container || document.body;
        container.removeChild(this.rootElement);
    };
    RawPopup.prototype.render = function () {
        var _a = this.props, theme = _a.theme, header = _a.header, children = _a.children, footer = _a.footer, isModal = _a.isModal, PopupUI = _a.PopupUI, isOpened = _a.isOpened, shouldCloseOnClickAway = _a.shouldCloseOnClickAway, onRequestClose = _a.onRequestClose;
        if (!isOpened) {
            return null;
        }
        var child = (React.createElement(RootClose_1.RootClose, { onRootClose: onRequestClose, ignoreKeyUp: !shouldCloseOnClickAway, ignoreClick: !shouldCloseOnClickAway || isModal },
            React.createElement(PopupUI, { theme: theme, isModal: isModal, header: header, innerRef: this.innerRef, footer: footer, onBackdropClick: this.handleBackdropClick }, children)));
        return react_dom_1.createPortal(child, this.rootElement);
    };
    RawPopup = tslib_1.__decorate([
        pure_1.PURE,
        tslib_1.__metadata("design:paramtypes", [Object])
    ], RawPopup);
    return RawPopup;
}(react_1.Component));
var defaults = with_defaults_1.withDefaults({
    PopupUI: popup_ui_component_1.PopupUI,
});
exports.Popup = withTheme_1.withTheme(exports.POPUP)(defaults(RawPopup));
//# sourceMappingURL=Popup.js.map