"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Popup_1 = require("./Popup");
var storybook_1 = require("@devexperts/tools/dist/utils/storybook");
var pure_1 = require("../../utils/pure");
var Demo_1 = require("../demo/Demo");
var Button_1 = require("../Button/Button");
var Selectbox_1 = require("../Selectbox/Selectbox");
var Control_1 = require("../Control/Control");
var Menu_1 = require("../Menu/Menu");
var css = require("./Popup.page.styl");
var theme = {
    container: css.container,
};
var popupTheme = {
    container: css.popup,
};
var header = React.createElement("div", null, "HEADER");
var footer = React.createElement("div", null, "FOOTER");
var Stateful = Control_1.stateful()(Selectbox_1.Selectbox);
var StatefulOpened = Control_1.stateful('isOpened', 'onToggle')(Stateful);
var PopupPage = /** @class */ (function (_super) {
    tslib_1.__extends(PopupPage, _super);
    function PopupPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isOpened: false,
            isModal: false,
            shouldCloseOnClickAway: false,
        };
        _this.onToggleClick = function () {
            _this.setState({
                isOpened: !_this.state.isOpened,
            });
        };
        _this.onIsModalChange = function () {
            _this.setState({
                isModal: !_this.state.isModal,
            });
        };
        _this.onCloseOnClickAwayChange = function () {
            _this.setState({
                shouldCloseOnClickAway: !_this.state.shouldCloseOnClickAway,
            });
        };
        _this.onPopupRequestClose = function () {
            _this.setState({
                isOpened: false,
            });
        };
        return _this;
    }
    PopupPage.prototype.componentDidMount = function () {
        var html = document.querySelector('html');
        if (html) {
            html.classList.add(css.html);
        }
    };
    PopupPage.prototype.componentWillUnmount = function () {
        var html = document.querySelector('html');
        if (html) {
            html.classList.remove(css.html);
        }
    };
    PopupPage.prototype.render = function () {
        var _a = this.state, isOpened = _a.isOpened, isModal = _a.isModal, shouldCloseOnClickAway = _a.shouldCloseOnClickAway;
        return (React.createElement(Demo_1.default, { theme: theme },
            React.createElement("label", { className: css.label },
                "Modal ",
                React.createElement("input", { type: "checkbox", value: isModal.toString(), onChange: this.onIsModalChange })),
            React.createElement("label", { className: css.label },
                "Close on clickaway",
                ' ',
                React.createElement("input", { type: "checkbox", value: shouldCloseOnClickAway.toString(), onChange: this.onCloseOnClickAwayChange })),
            !isModal &&
                shouldCloseOnClickAway && (React.createElement("label", { className: css.label }, "When isModal === false && shouldCloseOnClickAway === true popup will close on click inside inner selectbox, because there is no backdrop and selectbox is rendered to body")),
            React.createElement(Button_1.Button, { isPrimary: true, onClick: this.onToggleClick },
                isOpened ? 'Close' : 'Open',
                React.createElement(Popup_1.Popup, { theme: popupTheme, header: header, footer: footer, isModal: isModal, shouldCloseOnClickAway: shouldCloseOnClickAway, onRequestClose: this.onPopupRequestClose, isOpened: isOpened },
                    React.createElement("div", null, "popup content"),
                    React.createElement(StatefulOpened, { defaultValue: undefined, placeholder: "Choose your hero" },
                        React.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                        React.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                        React.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash"))))));
    };
    PopupPage = tslib_1.__decorate([
        pure_1.PURE
    ], PopupPage);
    return PopupPage;
}(React.Component));
storybook_1.storiesOf('Popup', module).add('Default', function () { return React.createElement(PopupPage, null); });
//# sourceMappingURL=Popup.page.js.map