import { ReactElement, ComponentClass } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare const TOGGLE_BUTTONS: symbol;
export declare type TToggleButtonsChildProps = {
    isActive?: boolean | undefined;
    isDisabled?: boolean;
    theme?: {
        container__vertical?: string;
        container__item?: string;
        container__item_active?: string;
    };
    onClick?: () => void;
};
export declare type TFullToggleButtonsProps = {
    children: ReactElement<TToggleButtonsChildProps>[];
    isDisabled?: boolean;
    isVertical?: boolean;
    toggleIndex?: number;
    defaultIndex?: number;
    onChange: Function;
    theme: {
        container?: string;
        container__wrapper?: string;
        container__vertical?: string;
        container__item?: string;
        container__item_active?: string;
    };
};
export declare type TToggleButtonsProps = PartialKeys<TFullToggleButtonsProps, 'theme'>;
export declare const ToggleButtons: ComponentClass<TToggleButtonsProps>;
