"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var storybook_1 = require("@devexperts/tools/dist/utils/storybook");
var Demo_1 = require("../demo/Demo");
var Input_1 = require("./Input");
var css = require("./Input.page.styl");
var demoCss = require("./Input.demo.styl");
var Control_1 = require("../Control/Control");
var darkDemoTheme = {
    container: css.container,
};
var Stateful = Control_1.stateful()(Input_1.Input);
storybook_1.storiesOf('Input', module)
    .add('Default', function () { return (React.createElement(Demo_1.Demo, { theme: darkDemoTheme },
    React.createElement(Stateful, { defaultValue: "<Input/>", onValueChange: storybook_1.action('change') }),
    React.createElement(Input_1.Input, { type: "hidden", tabIndex: 0, value: "123", onValueChange: undefined },
        React.createElement("div", { className: demoCss.input }, "div")))); })
    .add('Readonly', function () {
    return (React.createElement(Demo_1.Demo, { theme: darkDemoTheme },
        React.createElement(Stateful, { defaultValue: "<Input/>", isReadOnly: true })));
})
    .add('Disabled', function () {
    return (React.createElement(Demo_1.Demo, { theme: darkDemoTheme },
        React.createElement(Stateful, { defaultValue: "Test Value", isDisabled: true })));
})
    .add('Invalid', function () { return (React.createElement(Demo_1.Demo, { theme: darkDemoTheme },
    React.createElement(Stateful, { defaultValue: "Error", error: "Error" }))); });
//# sourceMappingURL=Input.page.js.map