import { ComponentType, Component } from 'react';
import { RemoteData } from '@devexperts/remote-data-ts';
export declare type TDataStateErrorMainProps<L> = {
    error: L;
};
export declare type TRenderRemoteDataStates<L> = {
    DataStateNoData: ComponentType;
    DataStateFailure: ComponentType<TDataStateErrorMainProps<L>>;
    DataStatePending: ComponentType;
};
export declare type TRenderRemoteDataMainProps<L, A> = {
    data: RemoteData<L, A>;
    success: (data: A) => JSX.Element;
    noData?: (data: A) => boolean;
};
export declare type TRenderRemoteDataProps<L, A> = TRenderRemoteDataStates<L> & TRenderRemoteDataMainProps<L, A>;
export declare class RenderRemoteData<L, A> extends Component<TRenderRemoteDataProps<L, A>> {
    render(): JSX.Element;
    private renderPending;
    private renderSuccess;
    private renderFailure;
}
